// Dedic2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream.h>

class A {
protected:
    int a;
public:
    A() { a = 0; }
};

class B : public virtual A {
protected:
    int b;
public:
    B() { b = 0; }
};

class C : public virtual A {
private:
    int c;
public:
    C() { c = 0; }
};

class D : public B, public C {
private:
    int d;
public:
    D() { d = 0; }
};

class E : public virtual A, public B, public C {
private:
    int e;
public:
    E() { e = 0; }

    void Test()
    {
        B::a = 1;
        C::a = 5;
        a = 0;        // Pokud dedime virtualne, pak je to povolene

        cout << "a    = " << a << endl;
        cout << "B::a = " << B::a << endl;
        cout << "C::a = " << C::a << endl;
    }
};

int main(int argc, char* argv[])
{
	E e;
	e.Test();

	char c;
	cin >> c;

	return 0;
}